execute as @a[scores={knl-t=1..}] run function k_knl:locksys/raycast/unlock/unlock4 with storage minecraft:unlock_s input

## admin unlock
execute as @a[gamemode=creative] unless entity @s[scores={knl_ad_un=0..}] run scoreboard players enable @s knl_ad_un
execute as @a[gamemode=!creative] if entity @s[scores={knl_ad_un=0..}] run scoreboard players reset @s knl_ad_un
execute as @a[scores={knl_ad_un=1..}] at @s run function k_knl:locksys/start

## lockpicking - test if lockpicking is enabled and run if player has a lockpick in hand.
execute if score lockpicking k_knl_options matches 1 run execute as @a[nbt={SelectedItem:{tag:{lockpick:1}}},predicate=k_knl:issneaking] at @s run function k_knl:lockpicking/raycast/cast
execute as @a[scores={k_knl_lockpicking=0..},predicate=!k_knl:issneaking] run function k_knl:lockpicking/resetlockpicking with entity @s
execute as @a unless score @s k_knl_lockpicking matches 0.. run scoreboard objectives remove k_knl_lockpicking

## remove bocklock if no block is around
execute as @e[tag=kknl_blocklock] at @s unless block ~ ~ ~ #k_knl:lockable run kill @s
execute as @e[tag=kknl_blocklock] at @s unless data block ~ ~ ~ Lock run kill @s

## run protection
execute at @e[tag=kknl_blocklock] if entity @p[distance=..10] unless score timeout k_knl_options matches 0.. run schedule function k_knl:protection/prestart 5t replace
execute at @e[tag=kknl_blocklock] if entity @p[distance=..10] unless score timeout k_knl_options matches 0.. run scoreboard players set timeout k_knl_options 1

execute at @e[tag=kknl_blocklock] if entity @e[type=tnt,distance=..10] run kill @e[type=tnt,distance=..10]